

#include "FORTRAN_TYPES.h"


/************************************************************************/
/************************************************************************/


REAL2 * allocReal2(int dim1, int dim2)
{
  REAL2 * retValue = malloc(sizeof(REAL2));
  if ( retValue != NULL ) {
    retValue->data = malloc(dim1 * dim2 * sizeof(REAL));
    if ( retValue->data != NULL ) {
      retValue->dim2  = dim2;
    } else {
      free(retValue);
      retValue = NULL;
    }
  }

  return retValue;
}


INTEGER2 * allocInteger2(int dim1, int dim2)
{
  INTEGER2 * retValue = malloc(sizeof(INTEGER2));
  if ( retValue != NULL ) {
    retValue->data = malloc(dim1 * dim2 * sizeof(INTEGER));
    if ( retValue->data != NULL ) {
      retValue->dim2  = dim2;
    } else {
      free(retValue);
      retValue = NULL;
    }
  }

  return retValue;
}


LOGICAL2 * allocLogical2(int dim1, int dim2)
{
  LOGICAL2 * retValue = malloc(sizeof(LOGICAL2));
  if ( retValue != NULL ) {
    retValue->data = malloc(dim1 * dim2 * sizeof(LOGICAL));
    if ( retValue->data != NULL ) {
      retValue->dim2  = dim2;
    } else {
      free(retValue);
      retValue = NULL;
    }
  }

  return retValue;
}


REAL3 * allocReal3(int dim1, int dim2, int dim3)
{
  REAL3 * retValue = malloc(sizeof(REAL3));
  if ( retValue != NULL ) {
    retValue->data = malloc(dim1 * dim2 * dim3 * sizeof(REAL));
    if ( retValue->data != NULL ) {
      retValue->dim23 = dim2 * dim3;
      retValue->dim3  = dim3;
    } else {
      free(retValue);
      retValue = NULL;
    }
  }

  return retValue;
}


INTEGER3 * allocInteger3(int dim1, int dim2, int dim3)
{
  INTEGER3 * retValue = malloc(sizeof(INTEGER3));
  if ( retValue != NULL ) {
    retValue->data = malloc(dim1 * dim2 * dim3 * sizeof(INTEGER));
    if ( retValue->data != NULL ) {
      retValue->dim23 = dim2 * dim3;
      retValue->dim3  = dim3;
    } else {
      free(retValue);
      retValue = NULL;
    }
  }

  return retValue;
}


LOGICAL3 * allocLogical3(int dim1, int dim2, int dim3)
{
  LOGICAL3 * retValue = malloc(sizeof(LOGICAL3));
  if ( retValue != NULL ) {
    retValue->data = malloc(dim1 * dim2 * dim3 * sizeof(LOGICAL));
    if ( retValue->data != NULL ) {
      retValue->dim23 = dim2 * dim3;
      retValue->dim3  = dim3;
    } else {
      free(retValue);
      retValue = NULL;
    }
  }

  return retValue;
}


/************************************************************************/
/************************************************************************/
